Home | Download | Screen shots | Discussion | Documentation
--- | --- | --- | --- | ---

# openvrml::mfcolorrgba Class Reference

A color_rgba array node field value. More...

`#include <openvrml/field_value.h>`

Inheritance diagram for openvrml::mfcolorrgba:
[legend]

List of all members.

## Public Types

typedef std::vector< color_rgba > | value_type
| The type of value.

## Public Member Functions

| mfcolorrgba (value_type::size_type n=0, const color_rgba &value=color_rgba()) throw ( std::bad_alloc )
| Construct.
| mfcolorrgba (const value_type &value) throw ( std::bad_alloc )
| Construct.
| mfcolorrgba (const mfcolorrgba &mfc)
| Construct a copy.
virtual | ~mfcolorrgba () throw ()
| Destroy.
mfcolorrgba & | operator= (const mfcolorrgba &mfc) throw ( std::bad_alloc )
| Assign.
const value_type & | value () const throw ()
| Access.
void | value (const value_type &val) throw ( std::bad_alloc )
| Mutate.
void | swap (mfcolorrgba &mfc) throw ()
| Swap.

## Static Public Attributes

static const type_id | field_value_type_id = mfcolorrgba_id
| `field_value::type_id` for this class.

## Private Member Functions

virtual std::auto_ptr < field_value > | do_clone () const throw ( std::bad_alloc )
| Polymorphically construct a copy.
virtual mfcolorrgba & | do_assign (const field_value &value) throw ( std::bad_cast , std::bad_alloc )
| Virtual assignment.
virtual type_id | do_type () const throw ()
| Get the `field_value::type_id` associated with this class.
virtual void | print (std::ostream &) const
| Print to an output stream.

## Related Functions

(Note that these are not member functions.)
bool | operator== (const mfcolorrgba &lhs, const mfcolorrgba &rhs) throw()
| Compare for equality.
bool | operator!= (const mfcolorrgba &lhs, const mfcolorrgba &rhs) throw()
| Compare for inequality.
template<> void | swap (openvrml::mfcolorrgba &a, openvrml::mfcolorrgba &b)
| Swap the values of `a` and `b`.

## Detailed Description

A color_rgba array node field value.

Model of
  Field Value

## Member Typedef Documentation

openvrml::mfcolorrgba::value_type

The type of value.

## Constructor & Destructor Documentation

openvrml::mfcolorrgba::mfcolorrgba | ( | value_type::size_type | n = `0`,
|  | const color_rgba & | value = `color_rgba()` |
| ) |  |  | throw ( std::bad_alloc )`[explicit]`

Construct.

Creates an `mfcolorrgba` with `n` copies of `value`.

Parameters:

  `[in]` | n | the number elements in the mfcolorrgba.
  `[in]` | value | used to initialize the mfcolorrgba.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Postcondition:
  size is `n`. Every element is a copy of `value`.

openvrml::mfcolorrgba::mfcolorrgba | ( | const value_type & | value | ) | throw ( std::bad_alloc )`[inline, explicit]`

Construct.

Parameters:

  `[in]` | value | initial value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

openvrml::mfcolorrgba::mfcolorrgba | ( | const mfcolorrgba & | mfc | ) |

Construct a copy.

Parameters:

  `[in]` | mfc | the instance to copy.

openvrml::mfcolorrgba::~mfcolorrgba | ( |  | ) | throw ()`[virtual]`

Destroy.

Each of the `mfcolorrgba`'s value elements is destroyed, and memory allocated for them (if any) is deallocated.

## Member Function Documentation

openvrml::mfcolorrgba & openvrml::mfcolorrgba::operator= | ( | const mfcolorrgba & | mfc | ) | throw ( std::bad_alloc )

Assign.

Parameters:

  `[in]` | mfc | the value to assign.

Returns:
  a reference to the instance.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

const openvrml::mfcolorrgba::value_type & openvrml::mfcolorrgba::value | ( |  | ) | const throw ()

Access.

Returns:
  the color_rgba values.

Reimplemented from openvrml::field_value.

void openvrml::mfcolorrgba::value | ( | const value_type & | val | ) | throw ( std::bad_alloc )

Mutate.

Parameters:

  `[in]` | val | the new value.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

void openvrml::mfcolorrgba::swap | ( | mfcolorrgba & | mfc | ) | throw ()

Swap.

Parameters:

  `[in,out]` | mfc | the value to swap with this one.

std::auto_ptr< openvrml::field_value > openvrml::mfcolorrgba::do_clone | ( |  | ) | const throw ( std::bad_alloc )`[private, virtual]`

Polymorphically construct a copy.

Returns:
  a pointer to a copy of the object.

Exceptions:

  | std::bad_alloc | if memory allocation fails.

Implements openvrml::field_value.

openvrml::mfcolorrgba & openvrml::mfcolorrgba::do_assign | ( | const field_value & | value | ) | throw ( std::bad_cast , std::bad_alloc )`[private, virtual]`

Virtual assignment.

Returns:
  a reference to the object.

Exceptions:

  | std::bad_cast | if `value` is not an mfcolorrgba object.
  | std::bad_alloc | if memory allocation fails.

openvrml::field_value::type_id openvrml::mfcolorrgba::do_type | ( |  | ) | const throw ()`[private, virtual]`

Get the `field_value::type_id` associated with this class.

Returns:
  `field_value::mfcolorrgba`.

Implements openvrml::field_value.

void openvrml::mfcolorrgba::print | ( | std::ostream & | out | ) | const`[private, virtual]`

Print to an output stream.

Parameters:

  `[in,out]` | out | an output stream.

Implements openvrml::field_value.

## Friends And Related Function Documentation

bool operator== | ( | const mfcolorrgba & | lhs,
|  | const mfcolorrgba & | rhs |
| ) |  |  | throw()`[related]`

Compare for equality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` have the same value; `false` otherwise.

bool operator!= | ( | const mfcolorrgba & | lhs,
|  | const mfcolorrgba & | rhs |
| ) |  |  | throw()`[related]`

Compare for inequality.

Parameters:

  `[in]` | lhs | left-hand operand.
  `[in]` | rhs | right-hand operand.

Returns:
  `true` if `lhs` and `rhs` do not have the same value; `false` otherwise.

template<> void swap | ( | openvrml::mfcolorrgba & | a,
|  | openvrml::mfcolorrgba & | b |
| ) |  |  | `[related]`

Swap the values of `a` and `b`.

Does not throw.

Parameters:

  `[in,out]` | a |
  `[in,out]` | b |

## Member Data Documentation

const openvrml::field_value::type_id openvrml::mfcolorrgba::field_value_type_id = mfcolorrgba_id`[static]`

`field_value::type_id` for this class.